/*
 * Copyright (C) 2007 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#if !defined HATP_SOCIALRULEDATA_HH_
#define HATP_SOCIALRULEDATA_HH_

#include<iostream>
#include<string>

#include "Substitution.hh"

class SocialRuleData
{
protected:
	/**
	* the substitution of current data
	*/
	Substitution* subst;

	/**
	* the number of times the rule is violated
	*/
	unsigned int nb;

public:
	explicit SocialRuleData(Substitution* argSubst, unsigned int argNb);
	Substitution* getSubstitution() const;
	unsigned int getNumber() const;
	~SocialRuleData();
};

/**
 * constructor : set subst to argSubst and nb to argNb
 */
inline SocialRuleData::SocialRuleData(Substitution* argSubst, unsigned int argNb)
	: subst(argSubst), nb(argNb)
{
}

/**
 * return subst
 */
inline Substitution* SocialRuleData::getSubstitution() const
{
	return subst;
}

/**
 * return nb
 */
inline unsigned int SocialRuleData::getNumber() const
{
	return nb;
}

/**
 * destructor: empty
 */
inline SocialRuleData::~SocialRuleData()
{
	delete subst;
}

#endif
